searchData={"items":[{"type":"task","title":"mix deploy.generate","doc":"Create deploy scripts and files for project.","ref":"Mix.Tasks.Deploy.Generate.html"},{"type":"task","title":"Usage - mix deploy.generate","doc":"# Create scripts and files\n    MIX_ENV=prod mix deploy.generate","ref":"Mix.Tasks.Deploy.Generate.html#module-usage"},{"type":"task","title":"mix deploy.init","doc":"Initialize template files.","ref":"Mix.Tasks.Deploy.Init.html"},{"type":"task","title":"Command line options - mix deploy.init","doc":"* `--template_dir` - target directory","ref":"Mix.Tasks.Deploy.Init.html#module-command-line-options"},{"type":"task","title":"Usage - mix deploy.init","doc":"# Copy default templates into your project\n    mix deploy.init","ref":"Mix.Tasks.Deploy.Init.html#module-usage"},{"type":"task","title":"mix deploy.local","doc":"This task deploys a Distillery release to the local machine.\n\nIt extracts the release tar to a timestamped directory like\n`/srv/:app/releases/20170619175601`, then makes a symlink\nfrom `/srv/:app/current` to it.\n\nThis module looks for configuration in the mix project, to get the app and version,\nand under the application environment under `mix_deploy`.","ref":"Mix.Tasks.Deploy.Local.html"},{"type":"task","title":"mix deploy.local.rollback","doc":"Update current symlink to point to the previous release directory.","ref":"Mix.Tasks.Deploy.Local.Rollback.html"},{"type":"extras","title":"README","doc":"![test workflow](https://github.com/cogini/mix_systemd/actions/workflows/test.yml/badge.svg)\n[![Contributor Covenant](https://img.shields.io/badge/Contributor%20Covenant-2.1-4baaaa.svg)](CODE_OF_CONDUCT.md)\n[![Module Version](https://img.shields.io/hexpm/v/mix_deploy.svg)](https://hex.pm/packages/mix_deploy)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/mix_deploy/)\n[![Total Download](https://img.shields.io/hexpm/dt/mix_deploy.svg)](https://hex.pm/packages/mix_deploy)\n[![License](https://img.shields.io/hexpm/l/mix_deploy.svg)](https://github.com/cogini/mix_deploy/blob/master/LICENSE.md)\n[![Last Updated](https://img.shields.io/github/last-commit/cogini/mix_deploy.svg)](https://github.com/cogini/mix_deploy/commits/master)\n\n# mix_deploy\n\n\nThis module generates scripts which help deploy an Erlang release, handling\ntasks such as creating initial directory structure, unpacking release files,\nmanaging configuration, and starting/stopping.  It supports deployment to the\nlocal machine, bare-metal servers, or cloud servers using e.g.,\n[AWS CodeDeploy](https://aws.amazon.com/codedeploy/).\n\nIt supports releases created with Elixir 1.9+\n[mix release](https://hexdocs.pm/mix/Mix.Tasks.Release.html)\nor [Distillery](https://hexdocs.pm/distillery/home.html).\n\nIt assumes that [mix_systemd](https://github.com/cogini/mix_systemd) is used to generate a\nsystemd unit file for the application, and shares conventions with it about naming files.\nSee [mix_systemd](https://github.com/cogini/mix_systemd) for examples.\n\nHere is [a complete example app](https://github.com/cogini/mix-deploy-example).","ref":"readme.html"},{"type":"extras","title":"Installation - README","doc":"Add `mix_deploy` to the list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:mix_deploy, \"~> 0.7\"},\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Example - README","doc":"A straightforward way to deploy an app is on a virtual private server at, e.g.,\n[Digital Ocean](https://m.do.co/c/150575a88316), building and deploying on the\nsame machine. Check out the code on the server, run `mix compile` to build, run\n`mix test`, then run `mix release` to generate a release. You then use the\nscripts generated by `mix_release` to set up the runtime environment, deploy\nthe release to the target dir, and run it supervised by systemd.","ref":"readme.html#example"},{"type":"extras","title":"Configure the app - README","doc":"Follow the Phoenix config process for\n[deployment](https://hexdocs.pm/phoenix/deployment.html) and\n[releases](https://hexdocs.pm/phoenix/releases.html).\n\nThe app should read runtime configuration such as the database connection from\nenvironment variables in `config/runtime.exs`. Generate a production secret\nwith `mix phx.gen.secret`.\n\nCreate a file with these environment vars and put it in `config/environment`, e.g.:\n\n```shell\nDATABASE_URL=\"ecto://foo:Sekr!t@localhost/foo\"\nSECRET_KEY_BASE=\"VXR6/fViPssuoAyqmr0SvAYBIaMrtiZLaQCn1TfB5NXaOzssHxtegfF+yM+/Senv\"\n```\n\nAdd the `config/environment` file to `.gitignore` so that any secrets do not\nget checked into git.","ref":"readme.html#configure-the-app"},{"type":"extras","title":"Configure `mix_deploy` and `mix_systemd` - README","doc":"Configure `mix_deploy` and `mix_systemd` in `config/prod.exs`.\n\n`mix_systemd` generates a systemd unit file which loads the configuration\nfor the app. On startup, it creates the specified directories for the app in\nthe standard locations.\n\n```elixir\nconfig :mix_systemd,\n  env_files: [\n    # Read environment vars from file /srv/foo/etc/environment if it exists\n    [\"-\", :deploy_dir, \"/etc/environment\"],\n    # Read environment vars from file /etc/foo/environment if it exists\n    [\"-\", :configuration_dir, \"/environment\"]\n  ],\n  # Set individual env vars\n  env_vars: [\n    \"PHX_SERVER=true\"\n    \"PORT=8080\",\n  ],\n  # Create standard config dirs\n  dirs: [\n    # /var/cache/foo\n    :cache,\n    # /etc/foo\n    :configuration,\n    # /var/log/foo\n    :logs,\n    # /run/foo\n    :runtime,\n    # /var/lib/foo\n    :state,\n    # /var/tmp/foo\n    :tmp\n  ],\n  # Run app under this OS user, default is the app name\n  app_user: \"app\",\n  app_group: \"app\"\n```\n\n`mix_deploy` generates scripts to initialize the system and deploy it.\n\n```elixir\nconfig :mix_deploy,\n  app_user: \"app\",\n  app_group: \"app\"\n  # Copy config/environment to /etc/foo/environment\n  copy_files: [\n    %{\n      src: \"config/environment\",\n      dst: [:configuration_dir, \"/environment\"],\n      user: \"$DEPLOY_USER\",\n      group: \"$APP_GROUP\",\n      mode: \"640\"\n    },\n  ],\n  # Generate these scripts in bin\n  templates: [\n    \"init-local\",\n    \"create-users\",\n    \"create-dirs\",\n    \"copy-files\",\n    \"enable\",\n    \"release\",\n    \"restart\",\n    \"rollback\",\n    \"start\",\n    \"stop\",\n  ]\n```","ref":"readme.html#configure-mix_deploy-and-mix_systemd"},{"type":"extras","title":"Initialize `mix_systemd` and `mix_deploy` and generate files - README","doc":"`mix_systemd` and `mix_deploy` generate output files from templates.\nRun the following to copy the templates into your project. The templating\nprocess most common needs via configuration, but you can also check them into\nyour project and make local modifications to handle special needs.\n\n```shell\nmix systemd.init\nmix deploy.init\n```\n\nGenerate output files:\n\n```shell\n# Create systemd unit file for app under _build/prod/systemd\nMIX_ENV=prod mix systemd.generate\n\n# Create deploy scripts project `bin` dir\nMIX_ENV=prod mix deploy.generate\nchmod +x bin/*\n```","ref":"readme.html#initialize-mix_systemd-and-mix_deploy-and-generate-files"},{"type":"extras","title":"Set up the system - README","doc":"Run the scripts to set up the operating system for the deployment.\nThis creates the app OS user, directory structure under `/srv/foo`, and the\nsystemd unit file which supervises the app.\n\n`deploy-init-local` is a convenience script which runs other scripts to set up\nthe system:\n\n```shell\nsudo bin/deploy-init-local\n```\n\nIt does the following:\n\n```shell\n# Create users to run the app\nbin/deploy-create-users\n\n# Create deploy dirs under /srv/foo\nbin/deploy-create-dirs\n\n# Copy scripts used at runtime by the systemd unit\ncp bin/* /srv/foo/bin\n\n# Copy files and enable systemd unit\nbin/deploy-copy-files\nbin/deploy-enable\n```","ref":"readme.html#set-up-the-system"},{"type":"extras","title":"Build the Elixir release - README","doc":"Create the Elixir (Erlang) release. This is a tar file containing the app, the\nlibraries it depends on, and the scripts to manage it.\n\n```shell\nMIX_ENV=prod mix release\n```","ref":"readme.html#build-the-elixir-release"},{"type":"extras","title":"Deploy the release to the local machine: - README","doc":"```shell\n# Extract release to target directory and make it current\nsudo bin/deploy-release\n\n# Restart the systemd unit\nsudo bin/deploy-restart\n```\n\nYou can roll back the release with the following:\n\n```shell\nbin/deploy-rollback\nsudo bin/deploy-restart\n```\n\nAdd an alias to `mix.exs`, and you can do the deploy by running `mix deploy`.\n\n```elixir\ndef project do\n  [\n    preferred_cli_env: [\n      deploy: :prod\n    ]\n  ]\nend\n\ndefp aliases do\n  [\n    deploy: [\n      \"release --overwrite\",\n      \"cmd sudo bin/deploy-release\",\n      \"cmd sudo bin/deploy-restart\"\n    ]\n  ]\nend\n```","ref":"readme.html#deploy-the-release-to-the-local-machine"},{"type":"extras","title":"Try it out - README","doc":"Your app should now be running:\n\n```shell\ncurl -v http://localhost:8080/\n```\n\nIf it is not, have a look at the logs.\n\n```shell\nsystemctl status foo\njournalctl -u foo\n```\n\nIf you want it to run on port 80, you can [redirect 80 to 8080\nin the firewall](https://www.cogini.com/blog/port-forwarding-with-iptables/).","ref":"readme.html#try-it-out"},{"type":"extras","title":"Usage - README","doc":"First, use the `deploy.init` task to template files from the library to the\n`rel/templates/deploy` directory in your project.\n\n```shell\nmix deploy.init\n```\n\nNext, generate the scripts based on your project's config:\n\n```shell\nMIX_ENV=prod mix deploy.generate\nchmod +x bin/*\n```\n\nBy default, `mix deploy.generate` creates scripts under a `bin` directory at\nthe top level of your project. If you want to keep them separate, e.g. to\ncreate different files based on the environment, set `bin_dir` to\n`[:output_dir, \"bin\"]` and it will generate files under e.g. `_build/prod/deploy`.","ref":"readme.html#usage"},{"type":"extras","title":"Configuration - README","doc":"The library tries to choose smart defaults. It reads the app name from\n`mix.exs` and calculates default values for its configuration parameters.\n\nIf your app is named `foo_bar`, it will create a service named `foo-bar`,\ndeployed to `/srv/foo-bar`, running under the user `foo-bar`.\n\nThe library doesn't generate any output scripts by default, you need to enable\nthem with the `templates` parameter. It can create the following scripts:","ref":"readme.html#configuration"},{"type":"extras","title":"Systemd scripts - README","doc":"These are wrappers on e.g. `/bin/systemctl restart foo`.  They are useful for\ne.g. CodeDeploy hook scripts where we have to run a script without parameters.\n\n* `deploy-start`: Start services\n* `deploy-stop`: Stop services\n* `deploy-restart`: Restart services\n* `deploy-enable`: Enable systemd units","ref":"readme.html#systemd-scripts"},{"type":"extras","title":"System setup scripts - README","doc":"These scripts set up the target system for the application. They are useful for\nlocal and automated deploy.\n\n* `deploy-create-users`: Create OS accounts for app and deploy users\n* `deploy-create-dirs`: Create dirs, including the release dir `/srv/foo` and\n  standard dirs like `/etc/foo` if needed.","ref":"readme.html#system-setup-scripts"},{"type":"extras","title":"Local deploy scripts - README","doc":"These scripts deploy the app to the same server as it was built on:\n\n* `deploy-copy-files`: Copy files from `_build` to target `/srv/foo`, or to a\n  staging directory for packaging\n* `deploy-release`: Deploy release, extracting to a timestamped dir under\n  `/srv/foo/releases`, then making a symlink from `/srv/foo/current`\n* `deploy-rollback`: Rollback release, resetting the symlink to point to the\n  previous release\n\nThe library also has mix tasks to deploy and roll back releases:\n\n```shell\nmix deploy.local\nmix deploy.local.rollback\n```","ref":"readme.html#local-deploy-scripts"},{"type":"extras","title":"CodeDeploy deploy scripts - README","doc":"These scripts run on the target machine as lifecycle hooks.\n\n* `deploy-clean-target`: Delete files under target dir\n   in preparation for deploying update\n* `deploy-extract-release`: Extract release from tar\n* `deploy-set-perms`: Set target file permissions so that they can be used by\n  the app user","ref":"readme.html#codedeploy-deploy-scripts"},{"type":"extras","title":"Build server scripts - README","doc":"These scripts run on the build server.\n\n* `deploy-stage-files`: Copy output files to staging directory, default `files`","ref":"readme.html#build-server-scripts"},{"type":"extras","title":"Release command scripts - README","doc":"These scripts set up the environment and then run release commands.\nThey make the config match the environment vars set at runtime in the systemd\nunit. With Elixir 1.9+ you can source `/srv/foo/bin/set-env` in `rel/env.sh.eex`.\nThe other scripts are mainly useful with Distillery.\n\n* `set-env`: Set up environment\n* `deploy-migrate`: Migrate database on target system by\n  [running a custom command](https://www.cogini.com/blog/running-ecto-migrations-in-a-release/).\n* `deploy-remote-console`: Launch remote console for the app","ref":"readme.html#release-command-scripts"},{"type":"extras","title":"Runtime environment scripts - README","doc":"These scripts are called by the systemd unit to set get the application config\nat runtime prior to starting the app. They are more most useful with Distillery.\n\nElixir 1.9+ mix releases support\n[runtime configuration](https://hexdocs.pm/mix/Mix.Tasks.Release.html#module-runtime-configuration)\nvia `config/runtime.exs` and `rel/env.sh.eex`. It is more secure, however, to\nseparate the process of getting configuration from the app itself using\n[ExecStartPre](https://www.freedesktop.org/software/systemd/man/systemd.service.html#ExecStartPre=)]).\nSee [mix_systemd](https://github.com/cogini/mix_systemd) for examples.\n\n* `deploy-sync-config-s3`: Sync config files from S3 bucket to app `configuration_dir`\n* `deploy-runtime-environment-file`: Create `#{runtime_dir}/environment`\n  file on target from `cloud-init` metadata\n* `deploy-runtime-environment-wrap`: Get runtime environment from `cloud-init`\n  [metadata](https://cloudinit.readthedocs.io/en/latest/topics/instancedata.html),\n  set environment vars, then launch main script.\n* `deploy-set-cookie-ssm`: Get Erlang VM cookie from [AWS SSM Parameter\n  Store](https://docs.aws.amazon.com/systems-manager/latest/userguide/systems-manager-paramstore.html)\n  and write to file.\n\nThe most useful of these is `deploy-sync-config-s3`, the rest are code you might copy into\n`rel/env.sh.eex`.","ref":"readme.html#runtime-environment-scripts"},{"type":"extras","title":"Dependencies - README","doc":"The generated scripts are mostly straight bash, with minimal dependencies.\n\n* `deploy-sync-config-s3` uses the [AWS CLI](https://aws.amazon.com/cli/)\n  to copy files from an S3 bucket.\n* `deploy-runtime-environment-file` and `deploy-runtime-environment-wrap` use\n   [jq](https://stedolan.github.io/jq/) to parse the\n   [cloud-init](https://cloud-init.io/) JSON file.\n* `deploy-set-cookie-ssm` uses the AWS CLI and `jq` to interact with\n  Systems Manager Parameter Store.\n\nTo install `jq` on Ubuntu:\n\n```shell\napt-get install jq\n```\n\nTo install the AWS CLI from the OS package manager on Ubuntu:\n\n```shell\napt-get install awscli\n```","ref":"readme.html#dependencies"},{"type":"extras","title":"Scenarios - README","doc":"","ref":"readme.html#scenarios"},{"type":"extras","title":"CodeDeploy - README","doc":"The library can generate lifecycle hook scripts for use with a\ndeployment system such as [AWS CodeDeploy](https://aws.amazon.com/codedeploy/).\n\n```elixir\nconfig :mix_deploy,\n  app_user: \"app\",\n  app_group: \"app\",\n  templates: [\n    \"stop\",\n    \"create-users\",\n    \"create-dirs\",\n    \"clean-target\",\n    \"extract-release\",\n    \"set-perms\",\n    \"migrate\",\n    \"enable\",\n    \"start\",\n    \"restart\",\n  ],\n    ...\n```\n\nHere is an example\n[appspec.yml](https://docs.aws.amazon.com/codedeploy/latest/userguide/reference-appspec-file-structure-hooks.html)\nfile:\n\n```yaml\nversion: 0.0\nos: linux\nfiles:\n  - source: bin\n    destination: /srv/foo/bin\n  - source: systemd\n    destination: /lib/systemd/system\n  - source: etc\n    destination: /srv/foo/etc\nhooks:\n  ApplicationStop:\n    - location: bin/deploy-stop\n      timeout: 300\n  BeforeInstall:\n    - location: bin/deploy-create-users\n    - location: bin/deploy-create-dirs\n    - location: bin/deploy-clean-target\n  AfterInstall:\n    - location: bin/deploy-extract-release\n    - location: bin/deploy-set-perms\n    - location: bin/deploy-enable\n  ApplicationStart:\n    - location: bin/deploy-migrate\n      runas: app\n      timeout: 300\n    - location: bin/deploy-start\n      timeout: 3600\n  # ValidateService:\n    - location: bin/validate-service\n      timeout: 300\n```","ref":"readme.html#codedeploy"},{"type":"extras","title":"Staging - README","doc":"By default, the scripts deploy the scripts as the same OS user that runs the\n`mix deploy.generate` command, and run the app under an OS user with the same\nname as the app.\n\nMany scripts allow you to override environment variables at execution time. For\nexample, you can override the user accounts which own the files by setting the\nenvironment vars `APP_USER`, `APP_GROUP`, and `DEPLOY_USER`.\n\nSimilarly, set `DESTDIR` and the copy script will add a prefix when copying\nfiles. This lets you copy files to a staging directory, tar it up, then extract\nit on a target machine, e.g.:\n\n```shell\nmkdir -p ~/tmp/deploy\nDESTDIR=~/tmp/deploy bin/deploy-create-dirs\nDESTDIR=~/tmp/deploy bin/deploy-copy-files\n```","ref":"readme.html#staging"},{"type":"extras","title":"Configuration options - README","doc":"The following sections describe common configuration options.\nSee `lib/mix/tasks/deploy.ex` for details of more obscure options.\n\nIf you need to make changes not supported by the config options,\nthen you can check the templates in `rel/templates/deploy`\ninto source control and make your own changes. Contributions are welcome!\n\nThe list of templates to generate is in the `templates` config var.\nYou can modify this list to remove scripts, and they won't be generated.\nYou can also add your own scripts and they will be run as templates with the\nconfig vars defined.","ref":"readme.html#configuration-options"},{"type":"extras","title":"Basics - README","doc":"`app_name`: Elixir application name, an atom, from the `app` field in the `mix.exs` project.\n\n`version`: `version` field in `mix.exs` project.\n\n`module_name`: Elixir camel case module name version of `app_name`, e.g. `FooBar`.\n\n`release_name`: Name of release, default `app_name`.\n\n`ext_name`: External name, used for files and directories,\ndefault `app_name` with underscores converted to \"-\", e.g. `foo-bar`.\n\n`service_name`: Name of the systemd service, default `ext_name`.\n\n`release_system`: `:mix | :distillery`, default `:mix`\n\nIdentifies the system used to generate the releases,\n[Mix](https://hexdocs.pm/mix/Mix.Tasks.Release.html) or\n[Distillery](https://hexdocs.pm/distillery/home.html).","ref":"readme.html#basics"},{"type":"extras","title":"Users - README","doc":"`deploy_user`: OS user account that is used to deploy the app, e.g. own the\nfiles and restart it. For security, this is separate from `app_user`, keeping\nthe runtime user from being able to modify the source files. Defaults to the\nuser running the script, supporting local deploy. For remote deploy, set this\nto a user like `deploy` or same as the app user.\n\n`deploy_group`: OS group account, default `deploy_user`.\n\n`app_user`: OS user account that the app should run under. Default `deploy_user`.\n\n`app_group`: OS group account, default `deploy_group`.","ref":"readme.html#users"},{"type":"extras","title":"Directories - README","doc":"`base_dir`: Base directory for app files on target, default `/srv`.\n\n`deploy_dir`: Directory for app files on target, default `#{base_dir}/#{ext_name}`.\n\nWe use the\n[standard app directories](https://www.freedesktop.org/software/systemd/man/systemd.exec.html#RuntimeDirectory=),\nfor modern Linux systems. App files are under `/srv`, configuration under\n`/etc`, transient files under `/run`, data under `/var/lib`.\n\nDirectories are named based on the app name, e.g. `/etc/#{ext_name}`.\nThe `dirs` variable specifies which directories the app uses.\nBy default, it doesn't set up anything. To enable them, configure `dirs`, e.g.:\n\n```elixir\ndirs: [\n  # :runtime,       # App runtime files which may be deleted between runs, /run/#{ext_name}\n  # :configuration, # App configuration, e.g. db passwords, /etc/#{ext_name}\n  # :state,         # App data or state persisted between runs, /var/lib/#{ext_name}\n  # :cache,         # App cache files which can be deleted, /var/cache/#{ext_name}\n  # :logs,          # App external log files, not via journald, /var/log/#{ext_name}\n  # :tmp,           # App temp files, /var/tmp/#{ext_name}\n],\n```\n\nRecent versions of systemd (since 235) will create these directories at\nstart time based on the settings in the unit file. For earlier systemd\nversions, `deploy-create-dirs` will create them.\n\nFor security, we set permissions to 750, more restrictive than the systemd\ndefaults of 755. You can configure them with variables like\n`configuration_directory_mode`. See the defaults in\n`lib/mix/tasks/deploy.ex`.\n\n`systemd_version`: Sets the systemd version on the target system, default 235.\nThis determines which systemd features the library will enable. If you are\ntargeting an older OS release, you may need to change it. Here are the systemd\nversions in common OS releases:\n\n* CentOS 7: 219\n* Ubuntu 16.04: 229\n* Ubuntu 18.04: 237","ref":"readme.html#directories"},{"type":"extras","title":"Additional directories - README","doc":"The library uses a directory structure under `deploy_dir` which supports\nmultiple releases, similar to [Capistrano](https://capistranorb.com/documentation/getting-started/structure/).\n\n* `scripts_dir`: deployment scripts which e.g. start and stop the unit, default `bin`.\n* `current_dir`: where the current Erlang release is unpacked or referenced by symlink, default `current`.\n* `releases_dir`: where versioned releases are unpacked, default `releases`.\n* `flags_dir`: dir for flag files to trigger restart, e.g. when `restart_method` is `:systemd_flag`, default `flags`.\n\nWhen using multiple releases and symlinks, the deployment process works as follows:\n\n1. Create a new directory for the release with a timestamp like\n   `/srv/foo/releases/20181114T072116`.\n\n2. Upload the new release tarball to the server and unpack it to the releases dir\n\n3. Make a symlink from `/srv/#{ext_name}/current` to the new release dir.\n\n4. Restart the app.\n\nIf you are only keeping a single version, then deploy it to the directory\n`/srv/#{ext_name}/current`.","ref":"readme.html#additional-directories"},{"type":"extras","title":"Variable expansion - README","doc":"The following variables support variable expansion:\n\n```elixir\nexpand_keys: [\n  :env_files,\n  :env_vars,\n  :runtime_environment_service_script,\n  :conform_conf_path,\n  :pid_file,\n  :root_directory,\n  :bin_dir,\n]\n```\n\nYou can specify values as a list of terms, and it will look up atoms as keys in\nthe config. This lets you reference e.g. the deploy dir or configuration dir without\nhaving to specify the full path, e.g. `[\"!\", :deploy_dir, \"/bin/myscript\"]` gets\nconverted to `\"!/srv/foo/bin/myscript\"`.","ref":"readme.html#variable-expansion"},{"type":"extras","title":"Environment vars - README","doc":"Config vars set a few common env vars:\n\n* `mix_env`: default `Mix.env()`, sets `MIX_ENV`\n* `env_lang`: default `en_US.utf8`, used to set `LANG`\n\nIn addition, you can set `env_vars` and `env_files` the same way\nas for `mix_systemd`. The `set-env` script will then set these\nvariables the same way as they are in the systemd unit,\nallowing you to run release commands with the same config, e.g. database\nmigrations or console. It also sets:\n\n* `RUNTIME_DIR`: `runtime_dir`, if `:runtime` in `dirs`\n* `CONFIGURATION_DIR`: `configuration_dir`, if `:configuration` in `dirs`\n* `LOGS_DIR`: `logs_dir`, if `:logs` in `dirs`\n* `CACHE_DIR`: `cache_dir`, if `:cache` in `dirs`\n* `STATE_DIR`: `state_dir`, if `:state` in `dirs`\n* `TMP_DIR`: `tmp_dir`, if `:tmp` in `dirs`\n\nYou can set additional vars using `env_vars`, e.g.:\n\n```elixir\nenv_vars: [\n  \"PORT=8080\",\n]\n```\nYou can also reference the value of other parameters by name, e.g.:\n\n```elixir\nenv_vars: [\n  [\"RELEASE_TMP=\", :runtime_dir],\n]\n```\n\nYou can read environment vars from files with `env_files`, e.g.:\n\n```elixir\nenv_files: [\n  [\"-\", :deploy_dir, \"/etc/environment\"],\n  [\"-\", :configuration_dir, \"environment\"],\n  [\"-\", :runtime_dir, \"environment\"],\n],\n```\n\nThe \"-\" at the beginning makes the file optional, the system will start without them.\nLater values override earlier values, so you can set defaults in the release which get\noverridden in the deployment or runtime environment.\n\nWith Distillery, you can generate a file under the release with an overlay in\n`rel/config.exs`, e.g.:\n\n```elixir\nenvironment :prod do\n  set overlays: [\n    {:mkdir, \"etc\"},\n    {:copy, \"rel/etc/environment\", \"etc/environment\"},\n    # {:template, \"rel/etc/environment\", \"etc/environment\"}\n  ]\nend\n```\n\nThat results in a file that would be read by:\n\n```elixir\nenv_files: [\n  [\"-\", :current_dir, \"/etc/environment\"],\n],\n```","ref":"readme.html#environment-vars"},{"type":"extras","title":"Starting and restarting - README","doc":"The following variables set systemd variables:\n\n`service_type`: `:simple | :exec | :notify | :forking`. systemd\n[Type](https://www.freedesktop.org/software/systemd/man/systemd.service.html#Type=), default `:simple`.\n\nModern applications don't fork, they run in the foreground and\nrely on the supervisor to manage them as a daemon. This is done by setting\n`service_type` to `:simple` or `:exec`. Note that in `simple` mode, systemd\ndoesn't actually check if the app started successfully, it just continues\nstarting other units. If something depends on your app being up, `:exec` may be\nbetter.\n\nSet `service_type` to `:forking`, and the library sets `pid_file` to\n`#{runtime_directory}/#{app_name}.pid` and sets the `PIDFILE` env var to tell\nthe boot scripts where it is.\n\nThe Erlang VM runs pretty well in foreground mode, but traditionally runs as\nas a standard Unix-style daemon, so forking might be better. Systemd\nexpects foregrounded apps to die when their pipe closes. See\nhttps://elixirforum.com/t/systemd-cant-shutdown-my-foreground-app-cleanly/14581/2\n\n`restart_method`: `:systemctl | :systemd_flag | :touch`, default `:systemctl`\n\nThe normal situation is that the app will be restarted using e.g.\n`systemctl restart foo`.\n\nWith `:systemd_flag`, an additional systemd unit file watches for\nchanges to a flag file and restarts the main unit. This allows updates to be\npushed to the target machine by an unprivileged user account which does not\nhave permissions to restart processes. Touch the file `#{flags_dir}/restart.flag`\nand systemd will restart the unit.  See `mix_systemd` for details.\n\nWith `:touch`, the app itself watches the file `#{flags_dir}/restart.flag`.\nIf it changes, the app shuts itself down, relying on systemd to notice and restart it.\n\n`sudo_deploy`: Creates `/etc/sudoers.d/#{ext_name}` file which allows the deploy\nuser to start/stop/restart the app using sudo. Default `false`. Note that\nwhen you must call systemctl with the full path, e.g. `sudo /bin/systemctl restart foo`\nfor this to work.\n\n`sudo_app`: Creates `/etc/sudoers.d/#{ext_name}` file allowing the app user\nuser to start/stop/restart the app using sudo. Default `false`.","ref":"readme.html#starting-and-restarting"},{"type":"extras","title":"Configuration examples - README","doc":"Here is a complete example of configuring an app from a config file which\nit pulls from S3 on startup.\n\nWe set up an `ExecStartPre` command in the systemd unit file which runs\n`deploy-sync-config-s3` before starting the app. It runs the AWS cli command:\n\n```shell\naws s3 sync \"s3://${CONFIG_S3_BUCKET}/${CONFIG_S3_PREFIX}\" \"${CONFIG_DIR}/\"\n```\n\n`CONFIG_S3_BUCKET` is the source bucket, and `CONFIG_S3_PREFIX` is an optional\npath in the bucket. `CONFIG_DIR` is the app configuration dir on the target\nsystem, `/etc/foo`.\n\nWe need to bootstrap the config process, so we use a different environment file\nfrom the main config.\n\n```shell\nmkdir -p rel/etc\necho \"CONFIG_S3_BUCKET=cogini-foo-dev-app-config\" >> rel/etc/environment\n```\n\nSet `exec_start_pre` in the `mix_systemd` config:\n\n```elixir\nconfig :mix_systemd,\n  app_user: \"app\",\n  app_group: \"app\",\n  # systemd runs this before starting the app as root\n  exec_start_pre: [\n    [\"!\", :deploy_dir, \"/bin/deploy-sync-config-s3\"]\n  ],\n  dirs: [\n    # Create /etc/foo\n    :configuration,\n    # Create /run/foo\n    :runtime,\n  ],\n  # systemd should not clean up /run/foo\n  runtime_directory_preserve: \"yes\",\n  # Load env from /srv/foo/etc/environment and /etc/foo/environment\n  env_files: [\n    [\"-\", :deploy_dir, \"/etc/environment\"],\n    [\"-\", :configuration_dir, \"/environment\"],\n  ],\n  # deploy-copy-files will copy the env file to /srv/foo/etc\n  # more likely it is done by e.g. appspec.yml\n  copy_files: [\n    %{\n      src: \"rel/etc/environment\",\n      dst: [:deploy_dir, \"/etc\"],\n      user: \"$DEPLOY_USER\",\n      group: \"$APP_GROUP\",\n      mode: \"640\"\n    },\n  ],\n  env_vars: [\n    # Temp files are in /run/foo\n    [\"RELEASE_TMP=\", :runtime_dir],\n  ]\n\nconfig :mix_deploy,\n  app_user: \"app\",\n  app_group: \"app\"\n  templates: [\n    \"init-local\",\n    \"create-users\",\n    \"create-dirs\",\n    \"copy-files\",\n    \"enable\",\n    \"release\",\n    \"restart\",\n    \"rollback\",\n    \"start\",\n    \"stop\",\n\n    \"sync-config-s3\",\n  ],\n  dirs: [\n    :configuration,\n    :runtime,\n  ],\n  # Set env config in e.g. deploy-set-env to match above.\n  env_files: [\n    [\"-\", :deploy_dir, \"/etc/environment\"],\n    [\"-\", :configuration_dir, \"/environment\"],\n  ]\n  env_vars: [\n    [\"RELEASE_TMP=\", :runtime_dir],\n  ]\n```\n\nFor security, the app only has read-only access to its config files, and\n`/etc/foo` has ownership `deploy:foo` and mode 750. We prefix the command\nwith \"!\" so it runs with elevated permissions, not as the `foo` user.\n\nWe need to set the `CONFIG_S3_BUCKET` variable in the environment so that\n`deploy-sync-config-s3` can use it. We can set it in `env_vars`\nor put it in the file `/etc/foo/environment`.\n\n* `/srv/foo/etc/environment` settings are configured at deploy time.\n* `/etc/foo/environment` settings might come from an S3\nbucket.\n* `/run/foo/environment` settings might be generated dynamically, e.g. getting\n  the IP address.\n\nFor example, `post_build` commands in the CodeBuild CI `buildspec.yml` file\ncan generate a config file `files/etc/environment`:\n\n```yaml\npost_build:\n  commands:\n    - mkdir -p files/etc\n    - echo \"CONFIG_S3_BUCKET=$BUCKET_CONFIG\" >> files/etc/environment\n```\n\nThen the CodeDeploy `appspec.yml` copies it to the target system under `/srv/foo/etc`:\n\n```yaml\nfiles:\n  - source: bin\n    destination: /srv/foo/bin\n  - source: systemd\n    destination: /lib/systemd/system\n  - source: etc\n    destination: /srv/foo/etc\n```\n\nSee [mix_systemd](https://github.com/cogini/mix_systemd) for more examples.\n\nI am `jakemorrison` on on the Elixir Slack and Discord, `reachfh` on\nFreenode `#elixir-lang` IRC channel. Happy to chat or help with\nyour projects.","ref":"readme.html#configuration-examples"},{"type":"extras","title":"Copyright and License - README","doc":"Copyright (c) 2019 Jake Morrison\n\nLicensed under the Apache License, Version 2.0 (the \"License\");\nyou may not use this file except in compliance with the License.\nYou may obtain a copy of the License at [https://www.apache.org/licenses/LICENSE-2.0](https://www.apache.org/licenses/LICENSE-2.0)\n\nUnless required by applicable law or agreed to in writing, software\ndistributed under the License is distributed on an \"AS IS\" BASIS,\nWITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\nSee the License for the specific language governing permissions and\nlimitations under the License.","ref":"readme.html#copyright-and-license"},{"type":"extras","title":"Changelog","doc":"# Changelog\nAll notable changes to this project will be documented in this file.\n\nThe format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),\nand this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).\n\n## [0.7.10] - 2024-07-07","ref":"changelog.html"},{"type":"extras","title":"Changed - Changelog","doc":"- Update libs\n\n## [0.7.9] - 2021-07-26","ref":"changelog.html#changed"},{"type":"extras","title":"Added - Changelog","doc":"- Ability to run custom function before starting, thanks @mitjok https://github.com/cogini/mix_deploy/pull/14\n\n## [0.7.8] - 2021-07-25","ref":"changelog.html#added"},{"type":"extras","title":"Fixed - Changelog","doc":"- Make Cmnd_Alias in /etc/sudoers.d file globally unique\n\n## [0.7.7] - 2020-12-08","ref":"changelog.html#fixed"},{"type":"extras","title":"Fixed - Changelog","doc":"- Fix incorrect file path copying /etc/sudoers.d file\n\n## [0.7.6] - 2020-10-07","ref":"changelog.html#fixed"},{"type":"extras","title":"Changed - Changelog","doc":"- Export vars to be visible in other scripts, thanks mitjok\n- Add ability to seed db, thanks mitjok\n- Update deps for Elixir 1.11\n- Update dialyxir version","ref":"changelog.html#changed"},{"type":"extras","title":"Fixed - Changelog","doc":"- Avoid duplicate keys in the bindings passed to EEx.eval_file, thanks vimalearnest\n- Pass dir as charlist to :erl_tar.extract\n\n## [0.7.5] - 2020-02-25","ref":"changelog.html#fixed"},{"type":"extras","title":"Fixed - Changelog","doc":"- Fix directory creation, closes https://github.com/cogini/mix_deploy/pull/7","ref":"changelog.html#fixed"},{"type":"extras","title":"Changed - Changelog","doc":"- Make ex_doc dev only dependency again\n- Update docs\n\n## [0.7.4] - 2020-02-12","ref":"changelog.html#changed"},{"type":"extras","title":"Changed - Changelog","doc":"- Update mix_systemd and ex_doc\n\n## [0.7.3] - 2020-01-24","ref":"changelog.html#changed"},{"type":"extras","title":"Fixed - Changelog","doc":"- Fix problem with newlines in set-env","ref":"changelog.html#fixed"},{"type":"extras","title":"Changed - Changelog","doc":"- Use default LANG of en_US.utf8 for better compatibility between Linux versions\n\n## [0.7.2] - 2020-01-21","ref":"changelog.html#changed"},{"type":"extras","title":"Changed - Changelog","doc":"- Updated migrate and console scripts for mix releases\n\n## [0.7.1] - 2020-01-01","ref":"changelog.html#changed"},{"type":"extras","title":"Fixed - Changelog","doc":"- Updated path to tar file, closes https://github.com/cogini/mix_deploy/pull/2\n\n## [0.7.0] - 2020-01-01","ref":"changelog.html#fixed"},{"type":"extras","title":"Added - Changelog","doc":"- Support Elixir 1.9 `mix release`\n- Support variable references in paths","ref":"changelog.html#added"},{"type":"extras","title":"Removed - Changelog","doc":"- Removed obsolete option flags","ref":"changelog.html#removed"},{"type":"extras","title":"License (Apache-2.0)","doc":"# Apache License\nVersion 2.0, January 2004\n\nhttp://www.apache.org/licenses/\n\nTERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION","ref":"license.html"},{"type":"extras","title":"1. Definitions. - License (Apache-2.0)","doc":"\"License\" shall mean the terms and conditions for use, reproduction, and\ndistribution as defined by Sections 1 through 9 of this document.\n\n\"Licensor\" shall mean the copyright owner or entity authorized by the copyright\nowner that is granting the License.\n\n\"Legal Entity\" shall mean the union of the acting entity and all other entities\nthat control, are controlled by, or are under common control with that entity.\nFor the purposes of this definition, \"control\" means (i) the power, direct or\nindirect, to cause the direction or management of such entity, whether by\ncontract or otherwise, or (ii) ownership of fifty percent (50%) or more of the\noutstanding shares, or (iii) beneficial ownership of such entity.\n\n\"You\" (or \"Your\") shall mean an individual or Legal Entity exercising\npermissions granted by this License.\n\n\"Source\" form shall mean the preferred form for making modifications, including\nbut not limited to software source code, documentation source, and configuration\nfiles.\n\n\"Object\" form shall mean any form resulting from mechanical transformation or\ntranslation of a Source form, including but not limited to compiled object code,\ngenerated documentation, and conversions to other media types.\n\n\"Work\" shall mean the work of authorship, whether in Source or Object form, made\navailable under the License, as indicated by a copyright notice that is included\nin or attached to the work (an example is provided in the Appendix below).\n\n\"Derivative Works\" shall mean any work, whether in Source or Object form, that\nis based on (or derived from) the Work and for which the editorial revisions,\nannotations, elaborations, or other modifications represent, as a whole, an\noriginal work of authorship. For the purposes of this License, Derivative Works\nshall not include works that remain separable from, or merely link (or bind by\nname) to the interfaces of, the Work and Derivative Works thereof.\n\n\"Contribution\" shall mean any work of authorship, including the original version\nof the Work and any modifications or additions to that Work or Derivative Works\nthereof, that is intentionally submitted to Licensor for inclusion in the Work\nby the copyright owner or by an individual or Legal Entity authorized to submit\non behalf of the copyright owner. For the purposes of this definition,\n\"submitted\" means any form of electronic, verbal, or written communication sent\nto the Licensor or its representatives, including but not limited to\ncommunication on electronic mailing lists, source code control systems, and\nissue tracking systems that are managed by, or on behalf of, the Licensor for\nthe purpose of discussing and improving the Work, but excluding communication\nthat is conspicuously marked or otherwise designated in writing by the copyright\nowner as \"Not a Contribution.\"\n\n\"Contributor\" shall mean Licensor and any individual or Legal Entity on behalf\nof whom a Contribution has been received by Licensor and subsequently\nincorporated within the Work.","ref":"license.html#1-definitions"},{"type":"extras","title":"2. Grant of Copyright License. - License (Apache-2.0)","doc":"Subject to the terms and conditions of this License, each Contributor hereby\ngrants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free,\nirrevocable copyright license to reproduce, prepare Derivative Works of,\npublicly display, publicly perform, sublicense, and distribute the Work and such\nDerivative Works in Source or Object form.","ref":"license.html#2-grant-of-copyright-license"},{"type":"extras","title":"3. Grant of Patent License. - License (Apache-2.0)","doc":"Subject to the terms and conditions of this License, each Contributor hereby\ngrants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free,\nirrevocable (except as stated in this section) patent license to make, have\nmade, use, offer to sell, sell, import, and otherwise transfer the Work, where\nsuch license applies only to those patent claims licensable by such Contributor\nthat are necessarily infringed by their Contribution(s) alone or by combination\nof their Contribution(s) with the Work to which such Contribution(s) was\nsubmitted. If You institute patent litigation against any entity (including a\ncross-claim or counterclaim in a lawsuit) alleging that the Work or a\nContribution incorporated within the Work constitutes direct or contributory\npatent infringement, then any patent licenses granted to You under this License\nfor that Work shall terminate as of the date such litigation is filed.","ref":"license.html#3-grant-of-patent-license"},{"type":"extras","title":"4. Redistribution. - License (Apache-2.0)","doc":"You may reproduce and distribute copies of the Work or Derivative Works thereof\nin any medium, with or without modifications, and in Source or Object form,\nprovided that You meet the following conditions:\n\n1. You must give any other recipients of the Work or Derivative Works a copy of\n   this License; and\n\n2. You must cause any modified files to carry prominent notices stating that\n   You changed the files; and\n\n3. You must retain, in the Source form of any Derivative Works that You\n   distribute, all copyright, patent, trademark, and attribution notices from\n   the Source form of the Work, excluding those notices that do not pertain to\n   any part of the Derivative Works; and\n\n4. If the Work includes a \"NOTICE\" text file as part of its distribution, then\n   any Derivative Works that You distribute must include a readable copy of the\n   attribution notices contained within such NOTICE file, excluding those\n   notices that do not pertain to any part of the Derivative Works, in at least\n   one of the following places: within a NOTICE text file distributed as part\n   of the Derivative Works; within the Source form or documentation, if\n   provided along with the Derivative Works; or, within a display generated by\n   the Derivative Works, if and wherever such third-party notices normally\n   appear. The contents of the NOTICE file are for informational purposes only\n   and do not modify the License. You may add Your own attribution notices\n   within Derivative Works that You distribute, alongside or as an addendum to\n   the NOTICE text from the Work, provided that such additional attribution\n   notices cannot be construed as modifying the License.\n\nYou may add Your own copyright statement to Your modifications and may provide\nadditional or different license terms and conditions for use, reproduction, or\ndistribution of Your modifications, or for any such Derivative Works as a whole,\nprovided Your use, reproduction, and distribution of the Work otherwise complies\nwith the conditions stated in this License.","ref":"license.html#4-redistribution"},{"type":"extras","title":"5. Submission of Contributions. - License (Apache-2.0)","doc":"Unless You explicitly state otherwise, any Contribution intentionally submitted\nfor inclusion in the Work by You to the Licensor shall be under the terms and\nconditions of this License, without any additional terms or conditions.\nNotwithstanding the above, nothing herein shall supersede or modify the terms of\nany separate license agreement you may have executed with Licensor regarding\nsuch Contributions.","ref":"license.html#5-submission-of-contributions"},{"type":"extras","title":"6. Trademarks. - License (Apache-2.0)","doc":"This License does not grant permission to use the trade names, trademarks,\nservice marks, or product names of the Licensor, except as required for\nreasonable and customary use in describing the origin of the Work and\nreproducing the content of the NOTICE file.","ref":"license.html#6-trademarks"},{"type":"extras","title":"7. Disclaimer of Warranty. - License (Apache-2.0)","doc":"Unless required by applicable law or agreed to in writing, Licensor provides the\nWork (and each Contributor provides its Contributions) on an \"AS IS\" BASIS,\nWITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied,\nincluding, without limitation, any warranties or conditions of TITLE, NON-\nINFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are\nsolely responsible for determining the appropriateness of using or\nredistributing the Work and assume any risks associated with Your exercise of\npermissions under this License.","ref":"license.html#7-disclaimer-of-warranty"},{"type":"extras","title":"8. Limitation of Liability. - License (Apache-2.0)","doc":"In no event and under no legal theory, whether in tort (including negligence),\ncontract, or otherwise, unless required by applicable law (such as deliberate\nand grossly negligent acts) or agreed to in writing, shall any Contributor be\nliable to You for damages, including any direct, indirect, special, incidental,\nor consequential damages of any character arising as a result of this License or\nout of the use or inability to use the Work (including but not limited to\ndamages for loss of goodwill, work stoppage, computer failure or malfunction, or\nany and all other commercial damages or losses), even if such Contributor has\nbeen advised of the possibility of such damages.","ref":"license.html#8-limitation-of-liability"},{"type":"extras","title":"9. Accepting Warranty or Additional Liability. - License (Apache-2.0)","doc":"While redistributing the Work or Derivative Works thereof, You may choose to\noffer, and charge a fee for, acceptance of support, warranty, indemnity, or\nother liability obligations and/or rights consistent with this License. However,\nin accepting such obligations, You may act only on Your own behalf and on Your\nsole responsibility, not on behalf of any other Contributor, and only if You\nagree to indemnify, defend, and hold each Contributor harmless for any liability\nincurred by, or claims asserted against, such Contributor by reason of your\naccepting any such warranty or additional liability.\n\nEND OF TERMS AND CONDITIONS\n\nCopyright 2021-2023, Jake Morrison  .\n\nLicensed under the Apache License, Version 2.0 (the \"License\");\nyou may not use this file except in compliance with the License.\nYou may obtain a copy of the License at\n\nhttp://www.apache.org/licenses/LICENSE-2.0\n\nUnless required by applicable law or agreed to in writing, software\ndistributed under the License is distributed on an \"AS IS\" BASIS,\nWITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\nSee the License for the specific language governing permissions and\nlimitations under the License.","ref":"license.html#9-accepting-warranty-or-additional-liability"},{"type":"extras","title":"Contributing","doc":"# Contributing to Uinta\n\nPlease take a moment to review this document in order to make the contribution\nprocess easy and effective for everyone involved!\nAlso make sure you read our [Code of Conduct](CODE_OF_CONDUCT.md) that outlines our commitment towards an open and welcoming environment.","ref":"contributing.html"},{"type":"extras","title":"Using the issue tracker - Contributing","doc":"Use the issues tracker for:\n\n* [Bug reports](#bug-reports)\n* [Submitting pull requests](#pull-requests)\n\nWe do our best to keep the issue tracker tidy and organized, making it useful\nfor everyone. For example, we classify open issues per perceived difficulty,\nmaking it easier for developers to [contribute to Uinta](#pull-requests).","ref":"contributing.html#using-the-issue-tracker"},{"type":"extras","title":"Bug reports - Contributing","doc":"A bug is either a _demonstrable problem_ that is caused by the code in the repository,\nor indicate missing, unclear, or misleading documentation. Good bug reports are extremely\nhelpful - thank you!\n\nGuidelines for bug reports:\n\n1. **Use the GitHub issue search** &mdash; check if the issue has already been\n   reported.\n\n2. **Check if the issue has been fixed** &mdash; try to reproduce it using the\n   `master` branch in the repository.\n\n3. **Isolate and report the problem** &mdash; ideally create a reduced test\n   case.\n\nPlease try to be as detailed as possible in your report. Include information about\nyour Operating System, as well as your Erlang, Elixir and Uinta versions. Please provide steps to\nreproduce the issue as well as the outcome you were expecting! All these details\nwill help developers to fix any potential bugs.\n\nExample:\n\n> Short and descriptive example bug report title\n>\n> A summary of the issue and the environment in which it occurs. If suitable,\n> include the steps required to reproduce the bug.\n>\n> 1. This is the first step\n> 2. This is the second step\n> 3. Further steps, etc.\n>\n> ` ` - a link to the reduced test case (e.g. a GitHub Gist)\n>\n> Any other information you want to share that is relevant to the issue being\n> reported. This might include the lines of code that you have identified as\n> causing the bug, and potential solutions (and your opinions on their\n> merits).","ref":"contributing.html#bug-reports"},{"type":"extras","title":"Contributing Documentation - Contributing","doc":"Code documentation (`@doc`, `@moduledoc`, `@typedoc`) has a special convention:\nthe first paragraph is considered to be a short summary.\n\nFor functions, macros and callbacks say what it will do. For example write\nsomething like:\n\n```elixir\n@doc \"\"\"\nMarks the given value as HTML safe.\n\"\"\"\ndef safe({:safe, value}), do: {:safe, value}\n```\n\nFor modules, protocols and types say what it is. For example write\nsomething like:\n\n```elixir\ndefmodule MyModule do\n  @moduledoc \"\"\"\n  Conveniences for working HTML strings and templates.\n  ...\n  \"\"\"\n```\n\nKeep in mind that the first paragraph might show up in a summary somewhere, long\ntexts in the first paragraph create very ugly summaries. As a rule of thumb\nanything longer than 80 characters is too long.\n\nTry to keep unnecessary details out of the first paragraph, it's only there to\ngive a user a quick idea of what the documented \"thing\" does/is. The rest of the\ndocumentation string can contain the details, for example when a value and when\n`nil` is returned.\n\nIf possible include examples, preferably in a form that works with doctests.\nThis makes it easy to test the examples so that they don't go stale and examples\nare often a great help in explaining what a function does.","ref":"contributing.html#contributing-documentation"},{"type":"extras","title":"Pull requests - Contributing","doc":"Good pull requests - patches, improvements, new features - are a fantastic\nhelp. They should remain focused in scope and avoid containing unrelated\ncommits.\n\n**IMPORTANT**: By submitting a patch, you agree that your work will be\nlicensed under the license used by the project.\n\nIf you have any large pull request in mind (e.g. implementing features,\nrefactoring code, etc), **please ask first** otherwise you risk spending\na lot of time working on something that the project's developers might\nnot want to merge into the project.\n\nPlease adhere to the coding conventions in the project (indentation,\naccurate comments, etc.) and don't forget to add your own tests and\ndocumentation. When working with git, we recommend the following process\nin order to craft an excellent pull request:\n\n1. [Fork](https://help.github.com/articles/fork-a-repo/) the project, clone your fork,\n   and configure the remotes:\n\n   ```bash\n   # Clone your fork of the repo into the current directory\n   git clone https://github.com/ /uinta\n\n   # Navigate to the newly cloned directory\n   cd uinta\n\n   # Assign the original repo to a remote called \"upstream\"\n   git remote add upstream https://github.com/podium/uinta\n   ```\n\n2. If you cloned a while ago, get the latest changes from upstream, and update your fork:\n\n   ```bash\n   git checkout master\n   git pull upstream master\n   git push\n   ```\n\n3. Create a new topic branch (off of `master`) to contain your feature, change,\n   or fix.\n\n   **IMPORTANT**: Making changes in `master` is discouraged. You should always\n   keep your local `master` in sync with upstream `master` and make your\n   changes in topic branches.\n\n   ```bash\n   git checkout -b  \n   ```\n\n4. Commit your changes in logical chunks. Keep your commit messages organized,\n   with a short description in the first line and more detailed information on\n   the following lines. Feel free to use Git's\n   [interactive rebase](https://help.github.com/articles/about-git-rebase/)\n   feature to tidy up your commits before making them public.\n\n5. Make sure all the tests are still passing.\n\n   ```bash\n   mix test\n   ```\n\n6. Push your topic branch up to your fork:\n\n   ```bash\n   git push origin  \n   ```\n\n7. [Open a Pull Request](https://help.github.com/articles/about-pull-requests/)\n    with a clear title and description.\n\n8. If you haven't updated your pull request for a while, you should consider\n   rebasing on master and resolving any conflicts.\n\n   **IMPORTANT**: _Never ever_ merge upstream `master` into your branches. You\n   should always `git rebase` on `master` to bring your changes up to date when\n   necessary.\n\n   ```bash\n   git checkout master\n   git pull upstream master\n   git checkout  \n   git rebase master\n   ```\n\nThank you for your contributions!","ref":"contributing.html#pull-requests"},{"type":"extras","title":"Guides - Contributing","doc":"These Guides aim to be inclusive. We use \"we\" and \"our\" instead of \"you\" and\n\"your\" to foster this sense of inclusion.\n\nIdeally there is something for everybody in each guide, from beginner to expert.\nThis is hard, maybe impossible. When we need to compromise, we do so on behalf\nof beginning users because expert users have more tools at their disposal to\nhelp themselves.\n\nThe general pattern we use for presenting information is to first introduce a\nsmall, discrete topic, then write a small amount of code to demonstrate the\nconcept, then verify that the code worked.\n\nIn this way, we build from small, easily digestible concepts into more complex\nones. The shorter this cycle is, as long as the information is still clear and\ncomplete, the better.\n\nFor formatting the guides:\n\n- We use the `elixir` code fence for all module code.\n- We use the `iex` for IEx sessions.\n- We use the `console` code fence for shell commands.\n- We use the `html` code fence for html templates, even if there is elixir code\n  in the template.\n- We use backticks for filenames and directory paths.\n- We use backticks for module names, function names, and variable names.\n- Documentation line length should hard wrapped at around 100 characters if possible.","ref":"contributing.html#guides"},{"type":"extras","title":"Code of Conduct","doc":"# Contributor Covenant Code of Conduct","ref":"code_of_conduct.html"},{"type":"extras","title":"Our Pledge - Code of Conduct","doc":"We as members, contributors, and leaders pledge to make participation in our\ncommunity a harassment-free experience for everyone, regardless of age, body\nsize, visible or invisible disability, ethnicity, sex characteristics, gender\nidentity and expression, level of experience, education, socio-economic status,\nnationality, personal appearance, race, caste, color, religion, or sexual\nidentity and orientation.\n\nWe pledge to act and interact in ways that contribute to an open, welcoming,\ndiverse, inclusive, and healthy community.","ref":"code_of_conduct.html#our-pledge"},{"type":"extras","title":"Our Standards - Code of Conduct","doc":"Examples of behavior that contributes to a positive environment for our\ncommunity include:\n\n* Demonstrating empathy and kindness toward other people\n* Being respectful of differing opinions, viewpoints, and experiences\n* Giving and gracefully accepting constructive feedback\n* Accepting responsibility and apologizing to those affected by our mistakes,\n  and learning from the experience\n* Focusing on what is best not just for us as individuals, but for the overall\n  community\n\nExamples of unacceptable behavior include:\n\n* The use of sexualized language or imagery, and sexual attention or advances of\n  any kind\n* Trolling, insulting or derogatory comments, and personal or political attacks\n* Public or private harassment\n* Publishing others' private information, such as a physical or email address,\n  without their explicit permission\n* Other conduct which could reasonably be considered inappropriate in a\n  professional setting","ref":"code_of_conduct.html#our-standards"},{"type":"extras","title":"Enforcement Responsibilities - Code of Conduct","doc":"Community leaders are responsible for clarifying and enforcing our standards of\nacceptable behavior and will take appropriate and fair corrective action in\nresponse to any behavior that they deem inappropriate, threatening, offensive,\nor harmful.\n\nCommunity leaders have the right and responsibility to remove, edit, or reject\ncomments, commits, code, wiki edits, issues, and other contributions that are\nnot aligned to this Code of Conduct, and will communicate reasons for moderation\ndecisions when appropriate.","ref":"code_of_conduct.html#enforcement-responsibilities"},{"type":"extras","title":"Scope - Code of Conduct","doc":"This Code of Conduct applies within all community spaces, and also applies when\nan individual is officially representing the community in public spaces.\nExamples of representing our community include using an official e-mail address,\nposting via an official social media account, or acting as an appointed\nrepresentative at an online or offline event.","ref":"code_of_conduct.html#scope"},{"type":"extras","title":"Enforcement - Code of Conduct","doc":"Instances of abusive, harassing, or otherwise unacceptable behavior may be\nreported to the community leaders responsible for enforcement at\nengineering@therealreal.com. All complaints will be reviewed and investigated\npromptly and fairly.\n\nAll community leaders are obligated to respect the privacy and security of the\nreporter of any incident.","ref":"code_of_conduct.html#enforcement"},{"type":"extras","title":"Enforcement Guidelines - Code of Conduct","doc":"Community leaders will follow these Community Impact Guidelines in determining\nthe consequences for any action they deem in violation of this Code of Conduct:","ref":"code_of_conduct.html#enforcement-guidelines"},{"type":"extras","title":"1. Correction - Code of Conduct","doc":"**Community Impact**: Use of inappropriate language or other behavior deemed\nunprofessional or unwelcome in the community.\n\n**Consequence**: A private, written warning from community leaders, providing\nclarity around the nature of the violation and an explanation of why the\nbehavior was inappropriate. A public apology may be requested.","ref":"code_of_conduct.html#1-correction"},{"type":"extras","title":"2. Warning - Code of Conduct","doc":"**Community Impact**: A violation through a single incident or series of\nactions.\n\n**Consequence**: A warning with consequences for continued behavior. No\ninteraction with the people involved, including unsolicited interaction with\nthose enforcing the Code of Conduct, for a specified period of time. This\nincludes avoiding interactions in community spaces as well as external channels\nlike social media. Violating these terms may lead to a temporary or permanent\nban.","ref":"code_of_conduct.html#2-warning"},{"type":"extras","title":"3. Temporary Ban - Code of Conduct","doc":"**Community Impact**: A serious violation of community standards, including\nsustained inappropriate behavior.\n\n**Consequence**: A temporary ban from any sort of interaction or public\ncommunication with the community for a specified period of time. No public or\nprivate interaction with the people involved, including unsolicited interaction\nwith those enforcing the Code of Conduct, is allowed during this period.\nViolating these terms may lead to a permanent ban.","ref":"code_of_conduct.html#3-temporary-ban"},{"type":"extras","title":"4. Permanent Ban - Code of Conduct","doc":"**Community Impact**: Demonstrating a pattern of violation of community\nstandards, including sustained inappropriate behavior, harassment of an\nindividual, or aggression toward or disparagement of classes of individuals.\n\n**Consequence**: A permanent ban from any sort of public interaction within the\ncommunity.","ref":"code_of_conduct.html#4-permanent-ban"},{"type":"extras","title":"Attribution - Code of Conduct","doc":"This Code of Conduct is adapted from the [Contributor Covenant][homepage],\nversion 2.1, available at\n[https://www.contributor-covenant.org/version/2/1/code_of_conduct.html][v2.1].\n\nCommunity Impact Guidelines were inspired by\n[Mozilla's code of conduct enforcement ladder][Mozilla CoC].\n\nFor answers to common questions about this code of conduct, see the FAQ at\n[https://www.contributor-covenant.org/faq][FAQ]. Translations are available at\n[https://www.contributor-covenant.org/translations][translations].\n\n[homepage]: https://www.contributor-covenant.org\n[v2.1]: https://www.contributor-covenant.org/version/2/1/code_of_conduct.html\n[Mozilla CoC]: https://github.com/mozilla/diversity\n[FAQ]: https://www.contributor-covenant.org/faq\n[translations]: https://www.contributor-covenant.org/translations","ref":"code_of_conduct.html#attribution"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,51,46,48]}}